#include <avr/io.h>
#include <util/delay.h>

#define delay_ms _delay_ms

typedef struct PIN
{
 volatile uint8_t *Port;
 unsigned char Nummer;
 unsigned char Data:1;
} PIN;

typedef struct LCD // Im Moment gibts nur den 4 Bit Modus
{
 PIN DB[8];
 PIN E;
 PIN RS;
} LCD;

void setport(volatile uint8_t *outputregister, uint8_t output);
void setbit(volatile uint8_t *outputregister, uint8_t outputbit);
void unsetbit(volatile uint8_t *outputregister, uint8_t outputbit);

int powi(int i,int n);

void LCD_Init(LCD lcd);				// Initialisierung eines LCD's
void LCD_ToggleEnable(LCD lcd);		// Toggle Enable(Enable Pin kurz high)

void LCD_SetData(LCD lcd,unsigned char data);	// Daten im DB Feld eintragen
void LCD_Set(LCD lcd);				// Pins setzen
void LCD_SwapData(LCD lcd);			// DB[4...7] durch DB[0...3] ersetzen

void LCD_SendData(LCD lcd);			// Daten an das LCD senden
void LCD_SendCommand(LCD lcd);		// Befehl an das LCD senden

void LCD_Clear(LCD lcd);			// LCD Bildschirminhalt lschen
